# Upwords - The Quick Stacking Word Game

## Getting Started

1. Install Upwords at the command prompt if you haven't yet:

        $ gem install upwords

2. At the command prompt, start a new Upwords game:

        $ upwords

3. Select the number of players:

        How many players will play? (1-4)
        3 

4. Name each player and select if they are humans or computers:
        
        What is Player 1's name? (Press enter to submit...)
        Bob 
        Is Bob a computer? (y/n)
        n   

        What is Player 2's name? (Press enter to submit...)
        Nina    
        Is Nina a computer? (y/n)
        n

        What is Player 3's name? (Press enter to submit...)
        Jack
        Is Jack a computer? (y/n)
        y

## Rules

Rules taken from: http://www.hasbro.com/common/instruct/04312.pdf

For 2 to 4 Players 1 AGES 8+

You and your opponents score points by spelling words with stackable
letter tiles on the special gameboard. You build words by blaying letters
across or down on the board and by stacking letters on top of letters
already on the board to form different words. It's this 3-dimensional
gameplay that makes UPWORDS so unique.

You score points for each letter in your word and every letter tile under
each letter of your word.Letters can be stacked five tiles high so your score
can really add up fast. Build words, stack letters, score high and have fun! 

## Objective

Build words to score the most points.

## Letter Distribution

| Letters       | Amount    |
| ------------- | --------- |
| J Qu V X Z    | 1 of each |
| K W Y         | 2 of each |
| B F G H P     | 3 of each |
| C             | 4 of each |
| D L M N R T U | 5 of each |
| S             | 6 of each |
| A I O         | 7 of each |
| E             | 8 of each |

## Setup

- Turn all of the tiles letter-side down and mix them up to create a draw pile.
- Each player takes a rack.
- Get a pencil and paper (not included) to keep score. Also keep a
  dictionary nearby to check the legality or spelling of any challenged
  word. See Rule 8 on page 5 for more information. Use the dictionary
  to settle challenges only. 

## Gameplay

### 1. Deciding Who Goes First

You and your opponents each draw one letter tile from the draw pile.
Whoever draws the tile nearest to the letter "A" plays first. Play then
passes to the left. Return the tiles, letter-side down, to the draw pile
and mix them up again.

### 2. Setting Up Racks 

You and your opponents draw seven letter tiles each.
Stand your tiles in your rack, as shown in Figure 1. Don't
let your opponents see 1 your letters.

[FIGURE 1]

### 3. First Turn

Whoever plays first must form a word of two letters or more that covers at least
one of the four game squares in the center of the gameboard.

### 4. Basic Turn

On your turn, play one or more letter tiles, either to form a new word that connects to
a word already on the board, or to change a word already on the board to a different word. 
All letters played on your turn must be in the same row of game squares either across or down. 
Tally and announce your point score, then draw letter tiles from the draw pile to replace 
the ones you played.

**IMPORTANT:** A word is legal and can be used in the game if it is in the dictionary and 
it does not fall into any of the categories of illegal words listed in Rule 7 on page 5. 

### 5. How To Form Words

Figures 2 through 7 show a sequence of plays. Arrows point out the word or words 
formed on each play. Point scores are given for each example. See Rule 6 on page
5 for details on scoring.

You can play letters to form a word that reads across (from left to right only) or down the
gameboard (never diagonally or up) and connects to a word already on the board. For
example, build down from the letter "D" in MOOD to form the word DEAR as shown in Figure 2. 
Build across using the letter "E" in DEAR to form the word NET as shown in Figure 3.
The word ON is also formed reading down.You score points for all of the words
formed during your turn.

    +----+----+----+----+----+----+
    |    |    |    |    |    |    |
    +----+----+----+----+----+----+
    |    | M  | O  | O  |{D} |    |
    +----+---1+---1+---1+---1+----+
    |    |    |    |    |{E} |    |
    +----+----+----+----+---1+----+
    |    |    |    |    |{A} |    |
    +----+----+----+----+---1+----+
    |    |    |    |    |{R} |    |
    +----+----+----+----+---1+----+
    |    |    |    |    |    |    |
    +----+----+----+----+----+----+

*Figure 2 - Score: 8 Points*

    +----+----+----+----+----+----+
    |    |    |    |    |    |    |
    +----+----+----+----+----+----+
    |    | M  | O  |{O} | D  |    |
    +----+---1+---1+---1+---1+----+
    |    |    |    |{N} |{E} |{T} |
    +----+----+----+---1+---1+---1+
    |    |    |    |    | A  |    |
    +----+----+----+----+---1+----+
    |    |    |    |    | R  |    |
    +----+----+----+----+---1+----+
    |    |    |    |    |    |    |
    +----+----+----+----+----+----+

*Figure 3 - Score: 10 Points* 


**NOTE:** Any letter in your word that is adjacent to another letter or letters on
the board must form a word. For example, in Figure 3, the letter "N" in NET is adjacent to
the letter "O" in MOOD, which forms the word ON.

#### Stacking Letters 

You can stack letters on top of letters already on the board to change a word into a different
word. For example, stack the letter "W" on top of the "M" in MOOD to change MOOD to WOOD as shown
in Figure 4. You cannot play more than one letter on the same stack during one turn. You cannot stack
a letter on the same letter - for example, and "A" on an "A."

**IMPORTANT:** Letters cannot be stacked more than five tiles high.

Figure 4 Score: 5 Points 

[FIGURE 4]

#### More on Stacking 

You can stack the letter "L" on top of the letter "D" and stack
the letter "P" on top of the letter "R" in the words WOOD
and DEAR to change them into the words WOOL and
LEAP as shown in Figure 5.

[FIGURE 5: Figure 5 Score: 12 Points]

**IMPORTANT:** When you change a word already on the board into a 
different word, at least one letter from the old word
must remain uncovered and be used in the new word. You cannot
stack letters to cover up an entire word. You can build a new word
and change a word already on the board into a different word
on the same turn. For example, build across stacking the
letter "N" on top of the letter "P" in LEAP to form the
word SNACK and change the word LEAP to LEAN as shown in Figure 6. 

[FIGURE 6 | Score: 14 Points] 

#### Plurals

You cannot simply add an "S"to a word already on the board to
form a plural. You can, however, play letters to form a word that connects
to a word already on the board to make it a plural. For example, build
down to form the word PLUS which connects with the word NET and
makes it plural as shown in Figure 7. You score points for both words.

[FIGURE 7 | Score: 16 Points]

### 6. How To Score Words

- You score 2 points per letter tile for any word formed with all letters
  only one tile high (no letter in the word is stacked on top of another
  letter). For example, the word DEAR in Figure 2 (page 3) contains four
  letters, and each is only one tile high. To score this word, just multiply
  4 times 2 for a total of 8 points.

- You score 1 point per letter tile for any word formed that contains any
  letters stacked two or more tiles high. Count each letter in your word
  and every letter tile under each letter of your word to get your score.
  For example, the word WOOD in Figure 4 (page 3) contains four letters
  plus one letter tile under then "W" for a total score of 5 points.

- You score 2 extra bonus points if you use the "Qu" letter tile in any word
  formed with all letters only one tile high. You do not receive any bonus
  points if you use the "Qu" tile in a word formed with any of its letters
  more than one tile high.

- You score 20 extra bonus points if you use all seven of your letter tiles
  in one turn.

- If you form two or more words on the same turn, each word is scored.
  Any letter or stack of letters common to these two words is scored for
  each word. For example, in Figure 3 (page 3), the lettern "N" is common to
  the words ON and NET. The word ON scores 4 points and the word NET
  scores 6 points for a total of 10 points for the turn.
  
- At the end of the game, 5 points are subtracted from your score for
  each letter tile you cannot play. 

### 7. Illegal Words

Any word that falls into any category listed below, is an illegal
word and cannot be used in the game:
- Words that are always capitalized are illegal.
- Words requiring a hyphen are illegal.
- Words requiring an apostrophe are illegal.
- Abbreviations and symbols are illegal.
- Prefixes and suffixes, that cannot stand alone, are illegal.
- Foreign words are illegal unless they appear in the dictionary.
- Words that are only one letter long are illegal. *(Note: Not Standard)*

### 8. Challenging A Word

You can challenge an opponent's word if you think it's misspelled or
an illegal word. The word must be challenged before another word is
played. Use a dictionary to decide if the challenged word is legal or
illegal. lf the challenged word is illegal, the player who played it removes
the letter tiles from the board and either plays another word or passes.

### 9. Passing

You may pass your turn at any time during the game. Sometimes it is to
your advantage to pass, especially toward the end of the game, to allow
a better scoring opportunity to open up for you. 

### 10. Exchanging Your Letters

On your turn, you may exchange one of your letter tiles for a new one.
Just turn the tile you want to exchange letter-side down and draw a
replacement tile from the draw pile. Return the tile you turned down to
the draw pile and mix it up. As a penalty, you lose your turn. Sometimes
it is a good strategy to give up a turn in order to exchange a letter. For
example, you may want to exchange a "J" or a "Z" if you draw them late
in the game.

### 11. How To End The Game

The game is over as soon as any of the following situations occur:
- When one player uses all of his or her letter tiles, and no tiles remain in
  the draw pile
- When none of the players can make a word on the board with the tiles
  they have left on their racks, and there are no more tiles in the draw pile
  (from which to exchange a letter tile)
- When all of the players pass their turn in consecutive order

When the game is over, total each player's final score. Subtract 5 points
from a player's score for each letter tile he/she has not played.

### How To Win

The player who scores the most points wins. 

### Solo Play Rules

Follow setup and gameplay rules as explained above. Make words, one at
a time, and score points for every word you make. **NOTE:** During the game,
you are allowed to exchange five letters (see Rule 10 above) without a
penalty.The game ends either (1) when all of the letter tiles have been
used, or (2) when you cannot make a word or exchange a letter tile. Total
up your score. Keep track of your solo game scores and try to improve
each time you play.

## Legal Disclaimers

SCRABBLE,the associated logo, the design of the distinctive SCRABBLE brand gameboard,

and the distinctive letter tile designs are trademarks of Hasbro in the United States and

Canada. All Rights Reserved.
